#----------------------------------------------------------------------------------#
#
# HYPERTAIL CONSOLE PREFERENCES
#
# FILE:			console_prefs.py
# AUTHOR:		Peter Quinn
# DATE:			10.02.2005
# VERSION:		1.00
#
# DESCRIPTION:	Console preferences for HyperTail.
#
#----------------------------------------------------------------------------------#

con_lines		= []

con_font		= "Monospace 7.5"
con_colour		= "#73FF8B"
con_xpos		= 0
con_ypos		= 0
con_width		= 0
con_height		= 0
con_samedim		= True
con_bgcolour	= "#000000A0"
con_bgimage		= ""
con_status		= False
con_done		= False

console.size	 = 20
console.filltype = " "


#----------------------------------------------------------------------------------#
#
#
#
#
def console_prefs(key, value):

	if		key == "con_font":			set_con_font(value)
	elif	key == "con_colour":		set_con_colour(value)
	elif	key == "con_xpos":			set_con_xpos(value)
	elif	key == "con_ypos":			set_con_ypos(value)
	elif	key == "con_width":			set_con_width(value)
	elif	key == "con_height":		set_con_height(value)
	elif	key == "con_bgcolour":		set_con_bgcolour(value)
	elif	key == "con_samedim":		set_con_samedim(value)
	elif	key == "windowsize" or key == "width":
		if con_samedim:
			set_con_samedim(con_samedim)
	
	
#----------------------------------------------------------------------------------#
#
#
#
#
def refresh_console():

	global con_lines

	conlines = console.read
	
	n = console.window_pos
	for i in range(con_height):
		if i < len(conlines):
			Dsp.consoleline[i].value = "%3d: %s" % (n, conlines[i])
		else:
			Dsp.consoleline[i].value = " "

		Dsp.consoleline[i].color = con_colour

		n += 1

	refresh_arrows()


#
#
#
def con_refresh(value):

	global con_done

	Dsp.statuswindow.visible = False

	ln = tail.console_output

	console.cursor		= 0
	console.window_pos	= 0
	console.size		= len(ln)
	console.fill		= " "
	console.write		= ln

	refresh_console()
	con_done = True


def con_execute(obj):

	console.fill		= " "

	for i in range(con_height):
		Dsp.consoleline[i].value = " "

	Dsp.statuswindow.visible = True
	Dsp.statuswindow.x = Unit((Dsp.consolebody.width.as_px() / 2) - (Dsp.statuswindow.width.as_px() / 2), PX)
	Dsp.statuswindow.y = Unit(Dsp.header.height.as_px(), PX) + Unit((Dsp.consolebody.height.as_px() / 2) - (Dsp.statuswindow.height.as_px() / 2), PX)
	
	tail.execute = obj


#----------------------------------------------------------------------------------#
#
#
#
#
def set_con_samedim(value):

	con_samedim = value
	
	Prefs.con_width.enabled		= con_samedim ^ 1
	Prefs.con_height.enabled	= con_samedim ^ 1
	Prefs.con_xpos.enabled		= con_samedim ^ 1
	Prefs.con_ypos.enabled		= con_samedim ^ 1

	if con_samedim:
		Prefs.con_width.value	= width
		Prefs.con_height.value	= windowsize
		Prefs.con_xpos.value	= 0
		Prefs.con_ypos.value	= 0
		Dsp.consolebody.width	= Unit(width, PX)
		Dsp.consolelog.length	= windowsize


#----------------------------------------------------------------------------------#
#
#
#
#
def set_con_font(value):

	con_font = value
	
	for i in range(con_height):
		Dsp.consoleline[i].font = con_font
		

#
#
#
def set_con_bgcolour(value):

	con_bgcolour = value

	Dsp.consolebody.bg_color = con_bgcolour


#
#
#
def set_con_colour(value):

	con_colour = value
	
	for i in range(con_height):
		Dsp.consoleline[i].color = con_colour


#
#
#
def set_con_xpos(value):

	con_xpos = value
	
	Dsp.consolebody.x = Unit(con_xpos, PX)


#
#
#
def set_con_ypos(value):

	con_ypos = value

	Dsp.consolebody.y = Unit(con_ypos, PX)


#
#
#
def set_con_width(value):

	con_width = value
	
	Dsp.consolebody.width	= Unit(con_width, PX)


#
#
#
def set_con_height(value):

	con_height				= value
	console.window_size		= con_height
	Dsp.consolelog.length	= con_height

	refresh_console()
	

#----------------------------------------------------------------------------------#

